/*
 * Sonar, entreprise quality control tool.
 * Copyright (C) 2007-2008 Hortis-GRC SA
 * mailto:be_agile HAT hortis DOT ch
 *
 * Sonar is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * Sonar is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with {library}; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02
 */
package ch.hortis.sonar.service;

import ch.hortis.sonar.model.Metric;
import ch.hortis.sonar.model.Metrics;

import javax.persistence.EntityManager;
import javax.persistence.FlushModeType;
import javax.persistence.NoResultException;
import javax.persistence.Query;
import java.util.Collection;

public class MetricService extends Service {

  public MetricService( EntityManager manager ) {
    super( manager );
  }
  
  public Metric getMetric( Metrics metric ) throws NoResultException {
    return getMetric( metric.getName() );
  }

  public Metric getMetric( String metricName ) throws NoResultException {
    Query query = manager.createNamedQuery( Metric.SQL_SELECT_BY_NAME );
    query.setFlushMode( FlushModeType.COMMIT );
    query.setParameter( "name", metricName );
    return (Metric) query.getSingleResult();
  }

  public Collection<Metric> getMetrics() {
    Query query = manager.createNamedQuery( Metric.SQL_SELECT_ALL );
    query.setFlushMode( FlushModeType.COMMIT );
    return query.getResultList();
  }
}
