package org.sonar.commons.database;

import java.sql.Connection;

public class InMemoryDatabaseConfiguration extends DatabaseConfiguration {
  public static final String HSQLDB_DRIVER = "org.hsqldb.jdbcDriver";

  public InMemoryDatabaseConfiguration(int databaseVersion) {
    super("jdbc:hsqldb:mem:sonar", HSQLDB_DRIVER, "sa", null);
    setIsolationLevel(Connection.TRANSACTION_READ_UNCOMMITTED);
    setCreateDatabaseFromHibernateMapping(databaseVersion);
  }

  public InMemoryDatabaseConfiguration() {
    this(DatabaseConfiguration.DATABASE_VERSION);
  }
}
