package org.sonar.commons.database.api;

import ch.hortis.sonar.model.Metric;

import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import java.util.HashMap;
import java.util.Map;

public class SaveOnDemandMetricsReferential implements MetricsReferential {
  private EntityManager entityManager;
  private Map<String, Metric> metricsByName = new HashMap<String, Metric>();

  public SaveOnDemandMetricsReferential(EntityManager entityManager) {
    this.entityManager = entityManager;
  }

  public Metric getMetric(Metric metric) {
    Metric result = metricsByName.get(metric.getName());
    if (result == null) {
      try {
        result = (Metric) entityManager.createQuery("select m from Metric m where m.name=:name").setParameter("name", metric.getName()).getSingleResult();

      } catch (NoResultException e) {
        // OK, the metric does not yet exist
      }
      if (result == null) {
        entityManager.getTransaction().begin();
        entityManager.persist(metric);
        entityManager.getTransaction().commit();
        result = metric;
      }
      metricsByName.put(result.getName(), result);
    }
    return result;
  }
}
